/*

definition for vvmpeg 1.0.1

use ffmpeg release version 0.6.1

2011-02-10

*/

#ifndef VVMPEG_H
#define VVMPEG_H

#define FFMPEG_VERSION "VVmpeg"
#define VVMPEG_MAJOR 1
#define VVMPEG_MINOR 0
#define VVMPEG_BUILD 1

// definition of Callback function
typedef DWORD (FAR PASCAL *NFFENCCB)(DWORD dwTotalLen, DWORD dwLength, DWORD dwUser);

// for frame counting
DWORD g_dwVFrmCnt = 0;
DWORD g_dwInputVFrmCnt = 0;

// for callback function user value(32bit pointer variable, like class pointer etc...)
DWORD g_dwUser = NULL;
// callback function pointer
NFFENCCB g_pfnCallback = NULL;

// main encode function
int EncodeMovie(int argc, char **argv, NFFENCCB pfnCallback, DWORD dwUser);

// for getting source format info
int GetFormatInfo(AVFormatContext* pSrcFmtCtx, int Index, int* pnWidth, int* pnHeight, double* pdFps, int* pnABitrate, int* pnSample, int* pnChannel, int* pnABit);

// for getting source file info
int GetMovieInfo(char* pszPath, DWORD* pdwDuration, int* pnBitrate, int* pnWidth, int* pnHeight, double* pdFps, int* pnABitrate, int* pnSample, int* pnChannel, int* pnABit);
int GetMovieInfo2(char* pszPath, DWORD* pdwDuration, int* pnBitrate, int* pnWidth, int* pnHeight, double* pdFps, int* pnABitrate, int* pnSample, int* pnChannel, int* pnABit, int* pnVCodec, int* pnACodec);

// for getting module version
int GetModuleVersion(int* pAVUtil, int* pAVCodec, int* pAVFormat, int* pAVDevice, char* pszVersion, int nVerString);

// for getting VVmpeg version
int GetVVmpegVersion(int* pMajor, int* pMinor, int* pBuild);

#endif /* VVMPEG_H */
